<?php

namespace App\DataTables;

use App\Models\PrenotazioneTavolo;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class PrenotazioneTavoloDataTableEditor extends DataTablesEditor
{
  protected $model = PrenotazioneTavolo::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'email.required' => 'L\'email è richiesta',
    'telefono.required' => 'Il telefono è richiesto',
    'tavolo_id.required' => 'Il tavolo è richiesto',
    'data_prenotazione.required' => 'La data prenotazione è richiesta',
    'ora_prenotazione.required' => 'L\'ora prenotazione è richiesta',
    'note.required' => 'La note è richiesta',
    'stato.required' => 'Il stato è richiesto',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'attivita_id' => 'required|exists:attivita,id',
      'nome' => 'required',
      'email' => 'required|email',
      'telefono' => 'nullable',
      'tavolo_id' => 'nullable|exists:tavolo,id',
      'data_prenotazione' => 'required|date',
      'ora_prenotazione' => 'required',
      'note' => 'nullable',
      'stato' => 'required|string|in:'.implode(',', PrenotazioneTavolo::getStati()->pluck('value', 'label')->toArray()),
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'attivita_id' => 'required|exists:attivita,id',
      'nome' => 'required',
      'email' => 'required|email',
      'telefono' => 'nullable',
      'tavolo_id' => 'nullable|exists:tavolo,id',
      'data_prenotazione' => 'required|date',
      'ora_prenotazione' => 'required',
      'note' => 'nullable',
      'stato' => 'required|string|in:'.implode(',', PrenotazioneTavolo::getStati()->pluck('value', 'label')->toArray()),
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
